<!--
 * @Description:It is troublesome to implement radio button group in the form. So it is extracted independently as a separate component
-->
<template>
  <div class="text-left">
    <RadioGroup
      :class="[style && Object.keys(style).length > 0 ? 'customStyle' : '']"
      v-bind="attrs"
      v-model:value="checked"
      :optionType="optionType"
      button-style="solid"
      @change="handleChange"
    >
      <template v-for="item in getOptions" :key="`${item.value}`">
        <RadioButton v-if="optionType === 'button'" :value="item.value" :disabled="item.disabled">
          {{ item.label }}
        </RadioButton>
        <Radio v-else :value="item.value" :disabled="item.disabled">
          {{ item.label }}
        </Radio>
      </template>
    </RadioGroup>
  </div>
</template>
<script lang="ts">
  import {
    defineComponent,
    PropType,
    ref,
    computed,
    unref,
    watch,
    inject,
    watchEffect,
    onMounted,
  } from 'vue';
  import { Radio } from 'ant-design-vue';
  import { isFunction } from '/@/utils/is';
  import { useAttrs } from '/@/hooks/core/useAttrs';
  import { propTypes } from '/@/utils/propTypes';
  import { get, omit } from 'lodash-es';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { getDicDetailList } from '/@/api/system/dic';
  import { getDatasourceData } from '/@/api/system/datasource';
  import { apiConfigFunc, camelCaseString, isValidJSON } from '/@/utils/event/design';

  type OptionsItem = { label: string; value: string | number | boolean; disabled?: boolean };

  export default defineComponent({
    name: 'ApiRadioGroup',
    components: {
      RadioGroup: Radio.Group,
      RadioButton: Radio.Button,
      Radio,
    },
    props: {
      api: {
        type: Function as PropType<(arg?: Recordable | string) => Promise<OptionsItem[]>>,
        default: null,
      },
      params: {
        type: [Object, String] as PropType<Recordable | string>,
        default: () => ({}),
      },
      value: {
        type: [String, Number, Boolean] as PropType<string | number | boolean>,
      },
      isBtn: {
        type: [Boolean] as PropType<boolean>,
        default: false,
      },
      numberToString: propTypes.bool,
      resultField: propTypes.string.def(''),
      labelField: propTypes.string.def('label'),
      valueField: propTypes.string.def('value'),
      immediate: propTypes.bool.def(true),
      //数据来源 默认为空  如果不为空 则参数 api
      datasourceType: String,
      optionType: propTypes.string.def('default'),
      staticOptions: {
        type: Array as PropType<OptionsItem[]>,
        default: () => [],
      },
      apiConfig: Object,
      mainKey: String,
      index: Number,
      isDesign: {
        type: Boolean,
        default: false,
      },
      style: Object,
    },
    emits: ['options-change', 'change', 'update:value'],
    setup(props, { emit }) {
      const options = ref<OptionsItem[]>([]);
      const loading = ref(false);
      const attrs = useAttrs();
      const { t } = useI18n();
      const formModel = inject<any>('formModel', null);
      const isCamelCase = inject<boolean>('isCamelCase', false);
      // Embedded in the form, just use the hook binding to perform form verification
      const checked = ref<string | number>('');
      // Processing options value
      const getOptions = computed(() => {
        const { labelField, valueField, numberToString } = props;
        return unref(options).reduce((prev, next: Recordable) => {
          if (next) {
            const value = next[valueField];
            prev.push({
              label: next[labelField],
              value: numberToString ? `${value}` : value,
              ...omit(next, [labelField, valueField]),
            });
          }
          return prev;
        }, [] as OptionsItem[]);
      });

      onMounted(() => {
        fetch();
      });
      watchEffect(() => {
        if (props.datasourceType === 'api' && props.apiConfig?.apiParams) {
          props.apiConfig.apiParams.forEach((params) => {
            params.tableInfo?.forEach((o) => {
              if (o.bindType == 'data') {
                let val = isValidJSON(o.value);
                let field = '';
                if (val && val.bindTable) {
                  let table = !isCamelCase
                    ? val.bindTable + 'List'
                    : camelCaseString(val.bindTable + '_List');
                  field = !isCamelCase ? val.bindField : camelCaseString(val.bindField);

                  formModel &&
                    formModel[table!][props.index || 0] &&
                    formModel[table!][props.index || 0][field];
                } else if (val && val.bindField) {
                  field = !isCamelCase ? val.bindField : camelCaseString(val.bindField);
                  formModel && formModel[field];
                }
              }
            });
          });
          fetch();
        }
      });
      watch(
        () => [props.params, props.datasourceType, props.apiConfig],
        () => {
          if (props.isDesign) {
            fetch();
          }
        },
        { deep: true, immediate: true },
      );

      watch(
        () => props.value,
        (val: any) => {
          checked.value = val;
        },
        {
          immediate: true,
        },
      );

      async function fetch() {
        let api;
        if (props.datasourceType) {
          if (props.datasourceType === 'dic') {
            api = getDicDetailList;
          }
          if (props.datasourceType === 'datasource') {
            api = getDatasourceData;
          }
          if (props.datasourceType === 'staticData') {
            options.value = props.staticOptions;
          }
          if (props.datasourceType === 'api') {
            options.value = await apiConfigFunc(
              props.apiConfig,
              isCamelCase,
              formModel,
              props.index,
            );
          }
        } else {
          api = props.api;
        }
        if (!api || !isFunction(api)) return;
        options.value = [];
        try {
          if (!props.params) return;
          loading.value = true;
          const res = await api(props.params);
          if (Array.isArray(res)) {
            options.value = res;
            emitChange();
            return;
          }
          if (props.resultField) {
            options.value = get(res, props.resultField) || [];
          }
          emitChange();
        } catch (error) {
          console.warn(error);
        } finally {
          loading.value = false;
        }
      }

      function emitChange() {
        emit('options-change', unref(getOptions));
      }

      function handleChange({ target }) {
        emit('update:value', target.value);
        emit('change');
      }
      const color = computed(() => {
        return props.style?.color;
      });
      const backgroundcolor = computed(() => {
        return props.style ? props.style['background-color'] : '#fff';
      });
      const border = computed(() => {
        return props.style?.border;
      });
      const fontsize = computed(() => {
        return props.style ? props.style['font-size'] : '14px';
      });
      const fontstyle = computed(() => {
        return props.style ? props.style['font-style'] : 'normal';
      });
      const width = computed(() => {
        return props.style?.width;
      });
      const height = computed(() => {
        return props.style?.height;
      });
      return {
        checked,
        getOptions,
        attrs,
        loading,
        t,
        handleChange,
        props,
        width,
        fontstyle,
        fontsize,
        border,
        backgroundcolor,
        color,
        height,
      };
    },
  });
</script>
<style scoped lang="less">
  .customStyle {
    width: v-bind(width);
    border: v-bind(border);
    background-color: v-bind(backgroundcolor);
    height: v-bind(height);
    font-size: v-bind(fontsize);
    font-style: v-bind(fontstyle);

    :deep(span.ant-radio + *) {
      color: v-bind(color);
    }
  }
</style>
